package ru.dbotthepony.mc.otm.compat.vanilla

import net.minecraft.core.registries.Registries
import net.minecraft.world.flag.FeatureFlags
import net.minecraft.world.inventory.MenuType
import net.neoforged.bus.api.IEventBus
import net.neoforged.neoforge.client.event.RegisterMenuScreensEvent
import ru.dbotthepony.mc.otm.OverdriveThatMatters
import ru.dbotthepony.mc.otm.registry.MDeferredRegister

object VanillaMenuTypes {
	private val registrar = MDeferredRegister(Registries.MENU, OverdriveThatMatters.MOD_ID)

	val GENERIC_9x1 by registrar.register("generic_9x1") { MenuType(MatteryChestMenu::c9x1, FeatureFlags.VANILLA_SET) }
	val GENERIC_9x2 by registrar.register("generic_9x2") { MenuType(MatteryChestMenu::c9x2, FeatureFlags.VANILLA_SET) }
	val GENERIC_9x3 by registrar.register("generic_9x3") { MenuType(MatteryChestMenu::c9x3, FeatureFlags.VANILLA_SET) }
	val GENERIC_9x4 by registrar.register("generic_9x4") { MenuType(MatteryChestMenu::c9x4, FeatureFlags.VANILLA_SET) }
	val GENERIC_9x5 by registrar.register("generic_9x5") { MenuType(MatteryChestMenu::c9x5, FeatureFlags.VANILLA_SET) }
	val GENERIC_9x6 by registrar.register("generic_9x6") { MenuType(MatteryChestMenu::c9x6, FeatureFlags.VANILLA_SET) }
	val GENERIC_3x3 by registrar.register("generic_3x3") { MenuType(MatteryChestMenu::c3x3, FeatureFlags.VANILLA_SET) }
	val HOPPER by registrar.register("hopper") { MenuType(MatteryChestMenu::hopper, FeatureFlags.VANILLA_SET) }

	val SHULKER_BOX by registrar.register("shulker_box") { MenuType(::MatteryShulkerBoxMenu, FeatureFlags.VANILLA_SET) }

	fun register(bus: IEventBus) {
		registrar.register(bus)
		bus.addListener(this::registerScreens)
	}

	private fun registerScreens(event: RegisterMenuScreensEvent) {
		event.register(GENERIC_9x1, ::VanillaChestScreen)
		event.register(GENERIC_9x2, ::VanillaChestScreen)
		event.register(GENERIC_9x3, ::VanillaChestScreen)
		event.register(GENERIC_9x4, ::VanillaChestScreen)
		event.register(GENERIC_9x5, ::VanillaChestScreen)
		event.register(GENERIC_9x6, ::VanillaChestScreen)
		event.register(GENERIC_3x3, ::VanillaChestScreen)
		event.register(HOPPER, ::VanillaChestScreen)
		event.register(SHULKER_BOX, ::VanillaChestScreen)
	}
}
